package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label2 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label3 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label4 = null;
public static int _ll = 0;
public static int _tt = 0;
public static int _ww = 0;
public static int _hh = 0;
public static int _k = 0;
public static int _bv = 0;
public static int _ln = 0;
public static int _qq = 0;
public static String _txt = "";
public static String[] _pictures = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 39;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 42;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="Pictures(0) = \"Balo0.png\"";
mostCurrent._pictures[(int) (0)] = "Balo0.png";
 //BA.debugLineNum = 45;BA.debugLine="Pictures(1) = \"Balo1.png\"";
mostCurrent._pictures[(int) (1)] = "Balo1.png";
 //BA.debugLineNum = 46;BA.debugLine="Pictures(2) = \"Balo2.png\"";
mostCurrent._pictures[(int) (2)] = "Balo2.png";
 //BA.debugLineNum = 47;BA.debugLine="Pictures(3) = \"Balo3.png\"";
mostCurrent._pictures[(int) (3)] = "Balo3.png";
 //BA.debugLineNum = 48;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 48;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_bv = _qq;
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 51;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _button1_longclick() throws Exception{
 //BA.debugLineNum = 138;BA.debugLine="Sub Button1_LongClick";
 //BA.debugLineNum = 139;BA.debugLine="LL = Button1.Left";
_ll = mostCurrent._button1.getLeft();
 //BA.debugLineNum = 140;BA.debugLine="TT = Button1.Top";
_tt = mostCurrent._button1.getTop();
 //BA.debugLineNum = 141;BA.debugLine="WW = Button1.Width";
_ww = mostCurrent._button1.getWidth();
 //BA.debugLineNum = 142;BA.debugLine="HH = Button1.Height";
_hh = mostCurrent._button1.getHeight();
 //BA.debugLineNum = 143;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 144;BA.debugLine="TXT = \"This is the Graphic help format on the right bottom side\"  '& TT & \" \" & LL";
mostCurrent._txt = "This is the Graphic help format on the right bottom side";
 //BA.debugLineNum = 145;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 146;BA.debugLine="End Sub";
return "";
}
public static String  _button2_longclick() throws Exception{
 //BA.debugLineNum = 148;BA.debugLine="Sub Button2_LongClick";
 //BA.debugLineNum = 149;BA.debugLine="LL = Button2.Left";
_ll = mostCurrent._button2.getLeft();
 //BA.debugLineNum = 150;BA.debugLine="TT = Button2.Top";
_tt = mostCurrent._button2.getTop();
 //BA.debugLineNum = 151;BA.debugLine="WW = Button2.Width";
_ww = mostCurrent._button2.getWidth();
 //BA.debugLineNum = 152;BA.debugLine="HH = Button2.Height";
_hh = mostCurrent._button2.getHeight();
 //BA.debugLineNum = 153;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 154;BA.debugLine="TXT = \"This is the Graphic help format on the left bottom side\" '& TT & \" \" & LL";
mostCurrent._txt = "This is the Graphic help format on the left bottom side";
 //BA.debugLineNum = 155;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 156;BA.debugLine="End Sub";
return "";
}
public static String  _clearlist() throws Exception{
int _m = 0;
 //BA.debugLineNum = 165;BA.debugLine="Sub ClearList";
 //BA.debugLineNum = 166;BA.debugLine="qq = Activity.NumberOfViews";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 167;BA.debugLine="For m = LN To BV Step -1";
{
final int step126 = (int) (-1);
final int limit126 = _bv;
for (_m = _ln; (step126 > 0 && _m <= limit126) || (step126 < 0 && _m >= limit126); _m = ((int)(0 + _m + step126))) {
 //BA.debugLineNum = 168;BA.debugLine="Activity.RemoveViewAt(m)";
mostCurrent._activity.RemoveViewAt(_m);
 }
};
 //BA.debugLineNum = 170;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
mostCurrent._txt = "";
 //BA.debugLineNum = 170;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_k = (int) (0);
 //BA.debugLineNum = 170;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_ll = (int) (0);
 //BA.debugLineNum = 170;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_tt = (int) (0);
 //BA.debugLineNum = 171;BA.debugLine="End Sub";
return "";
}
public static String  _creabal() throws Exception{
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
anywheresoftware.b4a.objects.LabelWrapper _lb = null;
 //BA.debugLineNum = 59;BA.debugLine="Sub CreaBal";
 //BA.debugLineNum = 60;BA.debugLine="Dim IV As ImageView";
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 61;BA.debugLine="IV.Initialize(\"ImageView\")";
_iv.Initialize(mostCurrent.activityBA,"ImageView");
 //BA.debugLineNum = 62;BA.debugLine="IV.BringToFront";
_iv.BringToFront();
 //BA.debugLineNum = 63;BA.debugLine="IV.Visible = True";
_iv.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 64;BA.debugLine="IV.Bitmap = LoadBitmap(File.DirAssets,Pictures(K))";
_iv.setBitmap((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),mostCurrent._pictures[_k]).getObject()));
 //BA.debugLineNum = 65;BA.debugLine="If K = 0 Then Activity.AddView(IV, LL, TT, 100dip, 100dip)";
if (_k==0) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,_tt,anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));};
 //BA.debugLineNum = 66;BA.debugLine="If K = 1 Then Activity.AddView(IV, LL-(100dip-WW), TT, 100dip, 100dip)";
if (_k==1) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),(int) (_ll-(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100))-_ww)),_tt,anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));};
 //BA.debugLineNum = 67;BA.debugLine="If K = 2 Then Activity.AddView(IV, LL, TT-(100dip-HH), 100dip, 100dip)";
if (_k==2) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,(int) (_tt-(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100))-_hh)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));};
 //BA.debugLineNum = 68;BA.debugLine="If K = 3 Then Activity.AddView(IV, LL, TT-(100dip-HH), 100dip, 100dip)";
if (_k==3) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,(int) (_tt-(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100))-_hh)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));};
 //BA.debugLineNum = 69;BA.debugLine="Dim LB As Label";
_lb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 70;BA.debugLine="LB.Initialize(\"Label\")";
_lb.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 71;BA.debugLine="LB.BringToFront";
_lb.BringToFront();
 //BA.debugLineNum = 72;BA.debugLine="LB.Visible = True";
_lb.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 73;BA.debugLine="LB.Color = Colors.White";
_lb.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 74;BA.debugLine="LB.TextColor = Colors.Black";
_lb.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 75;BA.debugLine="If K = 0 Then Activity.AddView(LB, LL+6, TT+35, 83, 42)";
if (_k==0) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+6),(int) (_tt+35),(int) (83),(int) (42));};
 //BA.debugLineNum = 76;BA.debugLine="If K = 1 Then Activity.AddView(LB, LL+6+(WW-100), TT+35, 83, 42)";
if (_k==1) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+6+(_ww-100)),(int) (_tt+35),(int) (83),(int) (42));};
 //BA.debugLineNum = 77;BA.debugLine="If K = 2 Then Activity.AddView(LB, LL+6, TT-(100-HH)+25, 83, 42)";
if (_k==2) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+6),(int) (_tt-(100-_hh)+25),(int) (83),(int) (42));};
 //BA.debugLineNum = 78;BA.debugLine="If K = 3 Then Activity.AddView(LB, LL+7, TT-(100-HH)+24, 83, 42)";
if (_k==3) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+7),(int) (_tt-(100-_hh)+24),(int) (83),(int) (42));};
 //BA.debugLineNum = 79;BA.debugLine="LB.TextSize = 8";
_lb.setTextSize((float) (8));
 //BA.debugLineNum = 80;BA.debugLine="LB.Text = TXT";
_lb.setText((Object)(mostCurrent._txt));
 //BA.debugLineNum = 81;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 81;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_ln = (int) (_qq-1);
 //BA.debugLineNum = 82;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Private Label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private Label2 As Label";
mostCurrent._label2 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private Label3 As Label";
mostCurrent._label3 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private Label4 As Label";
mostCurrent._label4 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim LL, TT, WW, HH As Int";
_ll = 0;
_tt = 0;
_ww = 0;
_hh = 0;
 //BA.debugLineNum = 31;BA.debugLine="Dim K, BV, LN, qq As Int";
_k = 0;
_bv = 0;
_ln = 0;
_qq = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim TXT As String";
mostCurrent._txt = "";
 //BA.debugLineNum = 33;BA.debugLine="Dim Pictures(4) As String Array";
mostCurrent._pictures = new String[(int) (4)];
java.util.Arrays.fill(mostCurrent._pictures,"");
 //BA.debugLineNum = 35;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Private Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
return "";
}
public static String  _imageview_click() throws Exception{
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
 //BA.debugLineNum = 84;BA.debugLine="Sub ImageView_click";
 //BA.debugLineNum = 85;BA.debugLine="Dim IV As ImageView";
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 86;BA.debugLine="IV.Initialize(\"ImageView\")";
_iv.Initialize(mostCurrent.activityBA,"ImageView");
 //BA.debugLineNum = 87;BA.debugLine="IV = Sender";
_iv.setObject((android.widget.ImageView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 88;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _label_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _lb = null;
 //BA.debugLineNum = 91;BA.debugLine="Sub Label_Click";
 //BA.debugLineNum = 92;BA.debugLine="Dim LB As Label";
_lb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 93;BA.debugLine="LB.Initialize(\"Label\")";
_lb.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 94;BA.debugLine="LB = Sender";
_lb.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 95;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 96;BA.debugLine="End Sub";
return "";
}
public static String  _label1_longclick() throws Exception{
 //BA.debugLineNum = 98;BA.debugLine="Sub Label1_LongClick";
 //BA.debugLineNum = 99;BA.debugLine="LL = Label1.Left";
_ll = mostCurrent._label1.getLeft();
 //BA.debugLineNum = 100;BA.debugLine="TT = Label1.Top";
_tt = mostCurrent._label1.getTop();
 //BA.debugLineNum = 101;BA.debugLine="WW = Label1.Width";
_ww = mostCurrent._label1.getWidth();
 //BA.debugLineNum = 102;BA.debugLine="HH = Label1.Height";
_hh = mostCurrent._label1.getHeight();
 //BA.debugLineNum = 103;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 104;BA.debugLine="TXT = \"This is the First test of a Baloon Graphic Help\"";
mostCurrent._txt = "This is the First test of a Baloon Graphic Help";
 //BA.debugLineNum = 105;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static String  _label2_longclick() throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Sub Label2_LongClick";
 //BA.debugLineNum = 109;BA.debugLine="LL = Label2.Left";
_ll = mostCurrent._label2.getLeft();
 //BA.debugLineNum = 110;BA.debugLine="TT = Label2.Top";
_tt = mostCurrent._label2.getTop();
 //BA.debugLineNum = 111;BA.debugLine="WW = Label1.Width";
_ww = mostCurrent._label1.getWidth();
 //BA.debugLineNum = 112;BA.debugLine="HH = Label1.Height";
_hh = mostCurrent._label1.getHeight();
 //BA.debugLineNum = 113;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 114;BA.debugLine="TXT = \"This is the Second test of a Baloon Graphic Help\"  '& TT";
mostCurrent._txt = "This is the Second test of a Baloon Graphic Help";
 //BA.debugLineNum = 115;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 116;BA.debugLine="End Sub";
return "";
}
public static String  _label3_longclick() throws Exception{
 //BA.debugLineNum = 118;BA.debugLine="Sub Label3_LongClick";
 //BA.debugLineNum = 119;BA.debugLine="LL = Label3.Left";
_ll = mostCurrent._label3.getLeft();
 //BA.debugLineNum = 120;BA.debugLine="TT = Label3.Top";
_tt = mostCurrent._label3.getTop();
 //BA.debugLineNum = 121;BA.debugLine="WW = Label3.Width";
_ww = mostCurrent._label3.getWidth();
 //BA.debugLineNum = 122;BA.debugLine="HH = Label3.Height";
_hh = mostCurrent._label3.getHeight();
 //BA.debugLineNum = 123;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 124;BA.debugLine="TXT = \"This is the standard format for the graphic help in center and left side of the page\"  '& TT & \" \" & LL";
mostCurrent._txt = "This is the standard format for the graphic help in center and left side of the page";
 //BA.debugLineNum = 125;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _label4_longclick() throws Exception{
 //BA.debugLineNum = 128;BA.debugLine="Sub Label4_LongClick";
 //BA.debugLineNum = 129;BA.debugLine="LL = Label4.Left";
_ll = mostCurrent._label4.getLeft();
 //BA.debugLineNum = 130;BA.debugLine="TT = Label4.Top";
_tt = mostCurrent._label4.getTop();
 //BA.debugLineNum = 131;BA.debugLine="WW = Label1.Width";
_ww = mostCurrent._label1.getWidth();
 //BA.debugLineNum = 132;BA.debugLine="HH = Label1.Height";
_hh = mostCurrent._label1.getHeight();
 //BA.debugLineNum = 133;BA.debugLine="SetPos";
_setpos();
 //BA.debugLineNum = 134;BA.debugLine="TXT = \"This is the standard format for the graphic left on right side\"   '& TT & \" \" & LL";
mostCurrent._txt = "This is the standard format for the graphic left on right side";
 //BA.debugLineNum = 135;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 136;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _setpos() throws Exception{
 //BA.debugLineNum = 158;BA.debugLine="Sub SetPos";
 //BA.debugLineNum = 159;BA.debugLine="If LL < 160 AND TT < 349 Then K = 0";
if (_ll<160 && _tt<349) { 
_k = (int) (0);};
 //BA.debugLineNum = 160;BA.debugLine="If LL > 160 AND TT < 349 Then K = 1";
if (_ll>160 && _tt<349) { 
_k = (int) (1);};
 //BA.debugLineNum = 161;BA.debugLine="If LL < 160 AND TT > 349 Then K = 2";
if (_ll<160 && _tt>349) { 
_k = (int) (2);};
 //BA.debugLineNum = 162;BA.debugLine="If LL > 160 AND TT > 349 Then K = 3";
if (_ll>160 && _tt>349) { 
_k = (int) (3);};
 //BA.debugLineNum = 163;BA.debugLine="End Sub";
return "";
}
}
